package cellular.gui;

import javax.swing.JTable;
import java.beans.BeanInfo;
import javax.swing.table.AbstractTableModel;
import java.beans.IntrospectionException;
import javax.swing.event.TableModelListener;
import javax.swing.table.TableModel;
import java.beans.PropertyDescriptor;

/**
 * <p> </p>
 * <p> </p>
 * <p> Copyright (c) 2003</p>
 * <p> WoCoWa</p>
 * @author Wouter Koolen-Wijkstra
 * @version 1.0
 */


class BeanTableModel extends AbstractTableModel
{
	int symbols =       2;
	int contextExtent = 1;
	int generations =   1000;
	int initialLength = 1;
	int minComplexity = 0;

	static final int    SYMBOLS = 0,
						CONTEXTEXTENT = 1,
						GENERATIONS = 2,
						INITIALLENGTH = 3,
						MINCOMPLEXITY = 4;


	public BeanTableModel()
	{
	}

    public int getRowCount()
    {
		return MINCOMPLEXITY+1;
    }
    public int getColumnCount()
    {
		return 2;
    }

	public String getColumnName(int parm1)
    {
		switch (parm1)
		{
			case 0: return "Property";
			case 1: return "Value";
			default: throw new Error("invalid case");
		}
    }

    public Class getColumnClass(int parm1)
    {
		switch (parm1)
		{
			case 0: return String.class;
			case 1: return Integer.class;
			default: throw new Error("invalid case");
		}
    }

	public boolean isCellEditable(int parm1, int parm2)
    {
		return parm2 == 1;
    }

    public Object getValueAt(int parm1, int parm2)
    {
		switch (parm2)
		{
			case 0: switch(parm1)
			        {
						case SYMBOLS:       return "# Symbols";
						case CONTEXTEXTENT: return "Context Extent";
						case GENERATIONS:   return "# Generations";
						case INITIALLENGTH: return "Initial Length";
						case MINCOMPLEXITY: return "Minimum Complexity";
						default: throw new Error("invalid case");
					}
			case 1: switch(parm1)
			        {
						case SYMBOLS:       return new Integer(symbols);
						case CONTEXTEXTENT: return new Integer(contextExtent);
						case GENERATIONS:   return new Integer(generations);
						case INITIALLENGTH: return new Integer(initialLength);
						case MINCOMPLEXITY: return new Integer(minComplexity);
						default: throw new Error("invalid case");
					}
			default: throw new Error("invalid case");
		}
    }

    public void setValueAt(Object parm1, int parm2, int parm3)
    {
		switch (parm3)
		{
			case 0: throw new Error("non-editable cell");
			case 1: switch(parm2)
			        {
						case SYMBOLS:       symbols =           ((Integer)parm1).intValue();  break;
						case CONTEXTEXTENT: contextExtent =     ((Integer)parm1).intValue();  break;
						case GENERATIONS:   generations =       ((Integer)parm1).intValue();  break;
						case INITIALLENGTH: initialLength =     ((Integer)parm1).intValue();  break;
						case MINCOMPLEXITY: minComplexity =     ((Integer)parm1).intValue();  break;
						default: throw new Error("invalid case");
					}
					break;
			default: throw new Error("invalid case");
		}
    }
    public int getContextExtent()
    {
        return contextExtent;
    }
    public int getGenerations()
    {
        return generations;
    }
    public int getInitialLength()
    {
        return initialLength;
    }
    public int getMinComplexity()
    {
        return minComplexity;
    }
    public int getSymbols()
    {
        return symbols;
    }
}

public class BeanTable extends JTable
{
	BeanTableModel model;

    public BeanTable()
    {
	    this(new BeanTableModel());
    }

	public BeanTable(BeanTableModel model)
	{
		super(model);
		this.model = model;

		this.setPreferredScrollableViewportSize(getPreferredSize());
	}

    public int getContextExtent()
    {
		return model.getContextExtent();
    }
    public int getGenerations()
    {
        return model.getGenerations();
    }
    public int getInitialLength()
    {
        return model.getInitialLength();
    }
    public int getMinComplexity()
    {
        return model.getMinComplexity();
    }
    public int getSymbols()
    {
        return model.getSymbols();
    }

}