package cellular.gui;

import javax.swing.*;
import java.awt.*;
import java.awt.Graphics;
import cellular.Evolution;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.image.MemoryImageSource;
import java.awt.image.IndexColorModel;
import java.awt.image.BufferedImage;


/**
 * <p> </p>
 * <p> </p>
 * <p> Copyright (c) 2003</p>
 * <p> WoCoWa</p>
 * @author Wouter Koolen-Wijkstra
 * @version 1.0
 */

public class Field extends JPanel
{
	Evolution       evolution;
    private         double zoom;
	public static final Color   []      palette = {Color.white, Color.black, Color.blue, Color.red, Color.green};
	Image           im;


    public Field(Evolution f)
    {
		this.setEvolution(f);

		java.awt.image.MemoryImageSource mis;
    }

	public void paintComponent (Graphics g1)
	{
		super.paintComponent(g1);
		if (evolution == null) return;

		Graphics2D g = (Graphics2D)g1;
		AffineTransform t = g.getTransform();
		g.scale(zoom,zoom);

//		Rectangle r = g.getClipBounds();
//
//		// pervert rectange use. (widht used as left bound, etc.)
//		r = new Rectangle(  Math.max(0, r.x),
//							Math.max(0, r.y),
//							Math.min(evolution.getWidth(), r.x + r.width),
//							Math.min(evolution.getHeight(), r.y + r.height));

//		for (int i = r.x; i < r.width; i++)
//		for (int j = r.y; j < r.height; j++)
//		{
//			g.setColor(palette[evolution.get(i,j)]);
//			g.drawRect(i,j,1,1);
//		}

		g.drawImage(im, 0, 0, this);

		g.setTransform(t);
	}


	public void setZoom(double zoom)
    {
        this.zoom = zoom;
		this.setPreferredSize(new Dimension((int)(zoom*evolution.getWidth()), (int)(zoom*evolution.getHeight())));
		this.revalidate();
		this.repaint();
    }

    public double getZoom()
    {
        return zoom;
    }


	public void setEvolution(Evolution evolution)
    {
        this.evolution = evolution;
		this.repaint();
		if (evolution != null)
		{
			this.setZoom(1);

			int w = evolution.getWidth();
			int h = evolution.getHeight();

			byte [] image = new byte[w * h];
			for (int i = 0; i < w; i++)
			for (int j = 0; j < h; j++)
			{
				image[w*j+i] = (byte)evolution.get(i,j);
			}

			byte [] r = new byte[palette.length];
			byte [] g = new byte[palette.length];
			byte [] b = new byte[palette.length];

			for (int i = 0; i < palette.length; i++)
			{
				r[i] = (byte)palette[i].getRed();
				g[i] = (byte)palette[i].getGreen();
				b[i] = (byte)palette[i].getBlue();
			}

			MemoryImageSource mis = new MemoryImageSource(w, h, new IndexColorModel(8, palette.length, r, g, b),image, 0, w);
			im = this.createImage(mis);
		}
    }


	public BufferedImage getImage()
	{
		BufferedImage bim = new BufferedImage(evolution.getWidth(), evolution.getHeight(), BufferedImage.TYPE_INT_RGB);
    	Graphics2D g2 = (Graphics2D)bim.getGraphics();

		g2.drawImage(im, 0, 0, this);

		return bim;
	}
}