package cellular.gui;

import java.awt.*;
import javax.swing.*;
import cellular.Evolution;
import cellular.Rule;
import cellular.k.*;
import java.awt.event.*;
import java.io.IOException;
import java.util.Arrays;
import java.io.ByteArrayOutputStream;
import javax.swing.SwingUtilities;
import java.awt.Cursor;
import java.math.BigInteger;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import com.sun.image.codec.jpeg.JPEGImageEncoder;
import com.sun.image.codec.jpeg.JPEGEncodeParam;
import com.sun.image.codec.jpeg.JPEGCodec;
import java.awt.image.BufferedImage;
import cellular.Version;

/**
 * <p> </p>
 * <p> </p>
 * <p> Copyright (c) 2003</p>
 * <p> WoCoWa</p>
 * @author Wouter Koolen-Wijkstra
 * @version 1.0
 */

public class Main extends JFrame
{
	static final Dimension   size = new Dimension(1800, 900);
	static final int symbols = 2, context = 1;

	Rule        r = null;
	Evolution   f = null;
    JPanel jPanel2 = new JPanel();
    Field jPanel1 = new Field(f);
    JScrollPane jScrollPane1 = new JScrollPane();
    BorderLayout borderLayout1 = new BorderLayout();
    JToolBar jToolBar1 = new JToolBar();
    JButton jButton4 = new JButton();

    public Main()
    {
        try
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
		Next();

		this.pack();
		this.setLocationRelativeTo(null);
		this.setVisible(true);
		this.setDefaultCloseOperation(this.EXIT_ON_CLOSE);
    }



	public static void main(String[] args)
    {
        new Main();
    }

	private void jbInit() throws Exception
    {

        this.setJMenuBar(jMenuBar1);
        this.setTitle("Cellular Workmate v" + Version.version);
        jPanel2.setLayout(borderLayout1);
        jButton4.setText("Generate");
        jButton4.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                Next();
            }
        });
        jPanel7.setBorder(BorderFactory.createRaisedBevelBorder());
        jPanel7.setLayout(borderLayout2);
        jPanel6.setBorder(BorderFactory.createRaisedBevelBorder());
        jPanel6.setLayout(borderLayout3);
        jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
        jLabel1.setText("New Simulation");
        jLabel2.setHorizontalAlignment(SwingConstants.CENTER);
        jLabel2.setText("Current Simulation");
        jPanel5.setBorder(BorderFactory.createRaisedBevelBorder());
        jPanel5.setLayout(borderLayout4);
        gridLayout1.setColumns(1);
        gridLayout1.setRows(3);
        jButton2.setFont(new java.awt.Font("Dialog", 1, 20));
        jButton2.setText("1");
        jButton2.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                setZoom(1);
            }
        });
        jButton1.setFont(new java.awt.Font("Dialog", 1, 20));
        jButton1.setText("-");
        jButton1.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                setZoom(jPanel1.getZoom()/2);
            }
        });
        jPanel4.setBorder(BorderFactory.createRaisedBevelBorder());
        jPanel4.setLayout(gridLayout1);
        jButton3.setFont(new java.awt.Font("Dialog", 1, 20));
        jButton3.setText("+");
        jButton3.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                setZoom(jPanel1.getZoom()*2);
            }
        });
        jLabel3.setText("Zoom");
        jPanel8.setLayout(borderLayout5);
        jTextField1.setText("boo");
        jTextField1.setColumns(10);
        jTextField1.setHorizontalAlignment(SwingConstants.CENTER);
        jTextField1.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                SetRuleByNumber(e);
            }
        });
        jLabel4.setHorizontalAlignment(SwingConstants.CENTER);
        jLabel4.setHorizontalTextPosition(SwingConstants.LEADING);
        jLabel4.setText("Rule number: ");
        jPanel9.setLayout(gridLayout2);
        gridLayout2.setColumns(1);
        gridLayout2.setRows(2);
        jPanel1.addMouseListener(new java.awt.event.MouseAdapter()
        {
            public void mousePressed(MouseEvent e)
            {
                MouseZoom(e);
            }
        });
        jMenu1.setText("File");
        jMenuItem1.setText("Save Image As...");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                jMenuItem1_actionPerformed(e);
            }
        });
        jMenu2.setText("Help");
        jMenuItem2.setText("About");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                About(e);
            }
        });
        jMenuItem3.setText("Quit");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                Quit(e);
            }
        });
        this.getContentPane().add(jPanel2,  BorderLayout.CENTER);
        jPanel2.add(jScrollPane1, BorderLayout.CENTER);
        jPanel2.add(jToolBar1, BorderLayout.SOUTH);

        jPanel4.add(jButton3, null);
        jPanel4.add(jButton2, null);
        jPanel4.add(jButton1, null);
        jPanel5.add(jLabel3, BorderLayout.NORTH);
        jPanel5.add(jPanel4, BorderLayout.CENTER);
        jPanel6.add(jScrollPane4, BorderLayout.CENTER);
        jPanel6.add(jButton4, BorderLayout.SOUTH);
        jPanel6.add(jLabel1, BorderLayout.NORTH);
        jToolBar1.add(jPanel5, null);
        jScrollPane4.getViewport().add(jTable2, null);
        jToolBar1.add(jPanel7, null);
        jToolBar1.add(jPanel6, null);

        jPanel7.add(jScrollPane3,  BorderLayout.CENTER);
        jPanel7.add(jLabel2, BorderLayout.NORTH);
        jScrollPane3.getViewport().add(jTable1, null);
        jPanel2.add(jPanel8, BorderLayout.NORTH);
        jPanel8.add(jScrollPane2, BorderLayout.CENTER);
        jPanel8.add(jPanel9,  BorderLayout.WEST);
        jPanel9.add(jLabel4, null);
        jPanel9.add(jTextField1, null);
        jScrollPane2.getViewport().add(jPanel3, null);
        jScrollPane1.getViewport().add(jPanel1, null);
        jMenuBar1.add(jMenu1);
        jMenuBar1.add(jMenu2);
        jMenu1.add(jMenuItem1);
        jMenu1.addSeparator();
        jMenu1.add(jMenuItem3);
        jMenu2.add(jMenuItem2);

		jPanel1.setCursor(Cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR));
    }

    void setZoom(double zoom)
    {
		JScrollBar ver = jScrollPane1.getVerticalScrollBar();
		JScrollBar hor = jScrollPane1.getHorizontalScrollBar();

		setZoom(zoom, hor.getValue() + hor.getVisibleAmount()/2, ver.getValue() + ver.getVisibleAmount()/2);
    }



    void setZoom(double zoom, int px, int py)
    {
		JScrollBar ver = jScrollPane1.getVerticalScrollBar();
		JScrollBar hor = jScrollPane1.getHorizontalScrollBar();

		double vcenter = (double)py / ver.getMaximum();
		double hcenter = (double)px / hor.getMaximum();

		jPanel1.setZoom(zoom);
		jScrollPane1.validate();

		ver.setValue((int)(ver.getMaximum()*vcenter)-ver.getVisibleAmount()/2);
		hor.setValue((int)(hor.getMaximum()*hcenter)-hor.getVisibleAmount()/2);
    }



	class Complexitizer extends Thread
	{
		long                complexity;
		OutputWriteable     ow;
		Compressor          c;

		public Complexitizer(Compressor c, OutputWriteable ow)
		{
			this.ow =   ow;
			this.c =    c;
		}

		public void run()
		{
			try
			{
				long time = System.currentTimeMillis();
				complexity = c.compress(ow);
				time = System.currentTimeMillis() - time;
				System.out.println(c.getName() + " " + time/1000.0 + " sec");
			}
			catch (IOException ex)
			{
				throw new Error(ex);
			}
		}

		public long getComplexity()
		{
			return complexity;
		}

	}


	public long [] compress(final OutputWriteable ow)
	{
		try
		{
			long []             length =    new long [k.length];
			Complexitizer []    workers =   new Complexitizer[k.length];

			for (int i = 0; i < k.length; i++)
			{
				workers[i] = new Complexitizer(k[i], f);
				workers[i].start();
			}

			for (int i = 0; i < k.length; i++)
			{
				workers[i].join();
				length[i] = workers[i].getComplexity();
			}
			return length;
		}
		catch (InterruptedException ex)
		{
			throw new Error(ex);
		}
	}


    void Next()
    {
		try
		{
			long    complexity;
			long [] complexities;

			Component   root =          SwingUtilities.getRoot(this);
			Cursor      oldCursor =     root.getCursor();

			root.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));

			do
			{
				r = new Rule(jTable2.getSymbols(),jTable2.getContextExtent()*2+1);
				f = new Evolution(jTable2.getGenerations(), r, jTable2.getInitialLength());

				complexities = this.compress(f);
				complexity = Long.MAX_VALUE;
				for (int i = 0; i < complexities.length; i++)
				{
				    complexity = Math.min(complexity, complexities[i]);
				}
				System.out.println("Model generated, K(x) <=" + complexity);
			} while(complexity < jTable2.getMinComplexity());

			root.setCursor(oldCursor);

			display(f, r, k, complexities);

		}
		catch (NumberFormatException ex)
		{
			JOptionPane.showMessageDialog(this, ex.getMessage(), "Numerical imput error", JOptionPane.ERROR_MESSAGE);
		}
    }


	final static Compressor [] k = { new Gzip(), new Jgzip(), new Bzip2(), new PPMd(), new Jcat(), new ExtremelyUselessCompressor() };
    JPanel jPanel7 = new JPanel();
    BorderLayout borderLayout2 = new BorderLayout();
    JScrollPane jScrollPane3 = new JScrollPane();
    CompressorTable jTable1 = new CompressorTable();
    JPanel jPanel6 = new JPanel();
    JScrollPane jScrollPane4 = new JScrollPane();
    BeanTable jTable2 = new BeanTable();
    BorderLayout borderLayout3 = new BorderLayout();
    JLabel jLabel1 = new JLabel();
    JLabel jLabel2 = new JLabel();
    JPanel jPanel5 = new JPanel();
    GridLayout gridLayout1 = new GridLayout();
    JButton jButton2 = new JButton();
    JButton jButton1 = new JButton();
    JPanel jPanel4 = new JPanel();
    JButton jButton3 = new JButton();
    JLabel jLabel3 = new JLabel();
    BorderLayout borderLayout4 = new BorderLayout();
    JPanel jPanel8 = new JPanel();
    JScrollPane jScrollPane2 = new JScrollPane();
    RuleDisplay jPanel3 = new RuleDisplay(r);
    BorderLayout borderLayout5 = new BorderLayout();
    JTextField jTextField1 = new JTextField();
    JPanel jPanel9 = new JPanel();
    JLabel jLabel4 = new JLabel();
    GridLayout gridLayout2 = new GridLayout();
    JMenuBar jMenuBar1 = new JMenuBar();
    JMenu jMenu1 = new JMenu();
    JMenuItem jMenuItem1 = new JMenuItem();
    JMenu jMenu2 = new JMenu();
    JMenuItem jMenuItem2 = new JMenuItem();

	void Compress()
    {

		try
		{
			String s = "";
			for (int i = 0; i < k.length; i++)
			{
				long length = k[i].compress(f);
				s += "Compressor: " + k[i].getName() + " length: " + length + "\n";
			}

			JOptionPane.showMessageDialog(this, s, "Compression result", JOptionPane.INFORMATION_MESSAGE);
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
			JOptionPane.showMessageDialog(this, ex.getMessage(), "Compression result", JOptionPane.ERROR_MESSAGE);
		}

    }
    void jButton2_actionPerformed(ActionEvent e)
    {

    }
    void jButton1_actionPerformed(ActionEvent e)
    {

    }
    void jButton3_actionPerformed(ActionEvent e)
    {

    }

    void SetRuleByNumber(ActionEvent e)
    {
		((Component)e.getSource()).setEnabled(false);
		Component   root =          SwingUtilities.getRoot(this);
		Cursor      oldCursor =     root.getCursor();

		root.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));

		BigInteger nrule = new BigInteger(jTextField1.getText());
		r = new Rule(jTable2.getSymbols(), 2*jTable2.getContextExtent()+1, nrule);
		f = new Evolution(jTable2.getGenerations(), r, jTable2.getInitialLength());

		long [] complexities = compress(f);

		root.setCursor(oldCursor);

		display(f, r, k, complexities);
		((Component)e.getSource()).setEnabled(true);
    }

	public void display(Evolution f, Rule r, Compressor [] k, long [] complexities)
	{
		jPanel1.setEvolution(f);
		jPanel3.setRule(r);

		jTable1.revalidate();
		jToolBar1.revalidate();

		this.jTable1.clear();
		for (int i = 0; i < complexities.length; i++)
		{
			if (complexities[i] != Long.MAX_VALUE)
			{
				jTable1.addCompressor(k[i], complexities[i]);
			}
		}

		String rn = r.getRuleNumber().toString();
		jTextField1.setColumns(rn.length());
		jTextField1.setText(rn);
		jTextField1.revalidate();
    }

    void MouseZoom(MouseEvent e)
    {
		switch (e.getButton())
		{
			case MouseEvent.BUTTON1:    setZoom(jPanel1.getZoom()*2, e.getX(), e.getY()); break;
			case MouseEvent.BUTTON2:    setZoom(jPanel1.getZoom(),   e.getX(), e.getY()); break;
			case MouseEvent.BUTTON3:    setZoom(jPanel1.getZoom()/2, e.getX(), e.getY()); break;
			default : throw new Error("Invalid case");
		}
    }



	void jMenuItem1_actionPerformed(ActionEvent e)
    {
		try
		{
			JFileChooser fs = new JFileChooser();

			if (fs.showSaveDialog(this) != JFileChooser.APPROVE_OPTION) return;

			File s = fs.getSelectedFile();
			if (!s.createNewFile()) throw new Exception("File exists or could not be created");


			BufferedImage           im =        jPanel1.getImage();
			BufferedOutputStream    out =       new BufferedOutputStream(new FileOutputStream(s));
            JPEGImageEncoder        encoder =   JPEGCodec.createJPEGEncoder(out);
	        JPEGEncodeParam         param =     encoder.getDefaultJPEGEncodeParam(im);

		    // Ensure total quality preservation !!!!
			param.setQuality(1.0f, false);
			for (int i = 0; i < param.getNumComponents(); i++)
			{
			    param.setVerticalSubsampling  (i, 1);
			    param.setHorizontalSubsampling(i, 1);
			}

			encoder.setJPEGEncodeParam(param);
	        encoder.encode(im);
			out.close();

		}
		catch (Exception ex)
		{
			ex.printStackTrace();
			JOptionPane.showMessageDialog(this, ex.getMessage(), "Image save error", JOptionPane.ERROR_MESSAGE);
		}

    }

	AboutBox dlg = new AboutBox(this);
    JMenuItem jMenuItem3 = new JMenuItem();

    void About(ActionEvent e)
    {
		dlg.setLocationRelativeTo(dlg.getOwner());
        dlg.setModal(true);
        dlg.show();
    }

    void Quit(ActionEvent e)
    {
		System.exit(0);
    }
}