package cellular.gui;

import javax.swing.JPanel;
import java.awt.geom.AffineTransform;
import java.awt.Graphics;
import java.awt.Graphics2D;
import cellular.Rule;
import java.awt.Dimension;

/**
 * <p> </p>
 * <p> </p>
 * <p> Copyright (c) 2003</p>
 * <p> WoCoWa</p>
 * @author Wouter Koolen-Wijkstra
 * @version 1.0
 */

public class RuleDisplay extends JPanel
{
	private Rule rule;
	int scale = 10;

    public RuleDisplay(Rule rule)
    {
		this.setRule(rule);
    }

	public void setRule(cellular.Rule rule)
    {
        this.rule = rule;
		if (rule != null)
		{
			Dimension size = new Dimension(rule.getNRules() * (rule.getContextExtent()*2+2) * scale, 2*scale);
			this.setPreferredSize(size);

			this.revalidate();
		}
		this.repaint();
    }


	public void paintComponent(Graphics g1)
	{
		super.paintComponent(g1);
		if (rule == null) return;

		Graphics2D g = (Graphics2D)g1;

		AffineTransform t = g.getTransform();

		g.scale(scale, scale);

		int [] xs = new int[rule.getContextExtent()*2+1];
		int dx = (rule.getContextExtent()*2+2);

		for (int i = 0; i < rule.getNRules(); i++)
		{
			for (int j = 0; j < xs.length; j++)
			{
				g.setColor(Field.palette[xs[j]]);
			    g.fillRect(i*dx+j, 0, 1, 1);
			}

			g.setColor(Field.palette[rule.evaluate(xs, xs.length/2)]);
			g.fillRect(i*dx+xs.length/2, 1, 1, 1);

			xs[0]++;
			for (int j = 0;  j < xs.length && xs[j] == rule.getSymbols(); j++)
			{
				xs[j] = 0;
				if (j+1 < xs.length) xs[j+1]++;
			}
		}

		g.setTransform(t);
	}

}