package cellular.k;

import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.BufferedInputStream;
import java.io.InputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.util.Arrays;

/**
 * <p> </p>
 * <p> </p>
 * <p> Copyright (c) 2003</p>
 * <p> WoCoWa</p>
 * @author Wouter Koolen-Wijkstra
 * @version 1.0
 */

public abstract class Compressor
{
    public abstract String getName();


	class ReaderThread extends Thread
	{
		long         read;
		InputStream is;

		ReaderThread(InputStream is)
		{
			this.is = is;
		}

		public void run()
		{
			byte [] buffer = new byte[10000];;
			try
			{
				int nread;
			    while ( (nread = is.read(buffer)) != -1) { read += nread; }
			}
			catch (IOException ex)
			{
				ex.printStackTrace();
				read = Long.MAX_VALUE;
			}
		}

		public long getRead()
		{
			return read;
		}
	};


	public abstract long compress(OutputWriteable ow) throws IOException;

	public long compressPipe(String [] cmdarray, OutputWriteable ow) throws IOException
	{
		try
		{
			Process p;

			try
			{
			    p = Runtime.getRuntime().exec(cmdarray);
			}
			catch (IOException ex)
			{
				return Long.MAX_VALUE;
			}

			final BufferedOutputStream    bos = new BufferedOutputStream(p.getOutputStream());
			final BufferedInputStream     bis = new BufferedInputStream(p.getInputStream());

			ReaderThread reader = new ReaderThread(bis);
			reader.start();

			ow.write(bos);
		    bos.close();

			p.waitFor();

			reader.join();
			bis.close();

			if (p.exitValue() == 0) return reader.getRead();
			else                    return Long.MAX_VALUE;
		}
		catch (InterruptedException ex)
		{
			throw new Error(ex);
		}
		catch (IOException ex)
		{
			return Long.MAX_VALUE;
		}
	}




	public long compressFile(String [] cmdarray, int fip, int fop, OutputWriteable ow) throws IOException
	{
		try
		{
			File tempIn =   File.createTempFile("compress", "in");
			File tempOut =  File.createTempFile("compress", "out");

			FileOutputStream        fos = new FileOutputStream(tempIn);
			BufferedOutputStream    bos = new BufferedOutputStream(fos);
			ow.write(bos);
			fos.close();

			cmdarray[fip] += tempIn.getAbsolutePath();
			cmdarray[fop] += tempOut.getAbsolutePath();

			tempOut.delete(); // some compressors don't like an existing output file...
			// BUT THIS (OF COURSE) CAUSES A RACE CONDITION HERE!

			try
			{
			    Process p = Runtime.getRuntime().exec(cmdarray);

				if (p.waitFor() == 0)   return tempOut.length();
	    		else                    return Long.MAX_VALUE;
			}
			catch (IOException ex)
			{
				return Long.MAX_VALUE;
			}
			finally
			{
	    		tempIn.delete();
				tempOut.delete();
			}
		}
		catch (InterruptedException ex)
		{
			throw new Error(ex);
		}
	}











}