package cellular.k;


import javax.swing.JTable;
import javax.swing.table.TableModel;
import javax.swing.table.AbstractTableModel;
import java.util.Vector;
import java.util.List;
import java.io.File;
import javax.swing.JComponent;
import javax.swing.table.TableCellRenderer;
import java.awt.Graphics;
import java.awt.Dimension;
import java.awt.Color;
import java.awt.Component;
import java.awt.Toolkit;
import java.awt.Rectangle;

/**
 * <p> </p>
 * <p> </p>
 * <p> Copyright (c) 2003</p>
 * <p> WoCoWa</p>
 * @author Wouter Koolen-Wijkstra
 * @version 1.0
 */




//class ProgressCellRenderer extends JComponent implements TableCellRenderer
//{
//	CompressorFileLine    line;
//	Color               back;
//	Color               front;
//    Color               text;
//
//	public void paint(Graphics g)
//	{
//		if (line == null) return;
//		Dimension d = getSize();
//		int split = (int)(d.getWidth() * line.progress/line.net.getSize());
//		g.setColor(front);
//		g.fillRect(0,0, split, d.height);
//		g.setColor(back);
//		g.fillRect(split,0, d.width, d.height);
//
//		String s = (1000*line.progress/line.net.getSize())/10.0 + "%";
//
//		Rectangle r = g.getFontMetrics().getStringBounds(s,g).getBounds();
//		g.setColor(text);
//		g.drawString(s, (d.width-r.x-r.width)/2, -r.y);
//	}
//
//
//	public Component 	getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column)
//	{
//	    line = (CompressorFileLine)table.getValueAt(row, column);
//		back = isSelected ? table.getSelectionBackground() : table.getBackground();
//		text = isSelected ? table.getSelectionForeground() : table.getForeground();
//
//		switch (line.status)
//		{
//			case CompressorFileLine.WORKING:
//				front = Color.blue.brighter();
//			break;
//
//			case CompressorFileLine.FAILED:
//				front = Color.red.darker();
//			break;
//
//			case CompressorFileLine.COMPLETED:
//				front = Color.green.darker();
//			break;
//			default:                            throw new Error("Unexpected case");
//		}
//		return this;
//	}
//}


class CompressorFileLine
{
	Compressor  compressor;
	long        size;


	public CompressorFileLine(Compressor compressor, long size)
	{
		this.compressor =   compressor;
		this.size =         size;
	}

	public long getSize()
	{
		return size;
	}

    public Compressor getCompressor()
    {
		return this.compressor;
    }
}


class CompressorModel extends AbstractTableModel
{
	List fileLines = new Vector();

	static final int    NAME = 0,
						SIZE = 1;


	public CompressorModel()
	{
	}

	// Returns the most specific superclass for all the cell values in the column.
    public Class 	getColumnClass(int columnIndex)
	{
	switch (columnIndex)
		{
			case NAME:      return String.class;
			case SIZE:      return Long.class;
			default:        throw new Error("Unexpected case");
		}
	}

	// Returns the number of columns in the model.
    public int 	getColumnCount()
	{
		return SIZE+1;
	}

	// Returns the name of the column at columnIndex.
    public String 	getColumnName(int columnIndex)
	{
		switch (columnIndex)
		{
			case NAME:      return "Compressor";
			case SIZE:      return "Size";
			default:        throw new Error("Unexpected case");
		}
	}

	// Returns the number of rows in the model.
    public int 	getRowCount()
	{
		return fileLines.size();
	}


	// Returns the value for the cell at columnIndex and rowIndex.
    public Object 	getValueAt(int rowIndex, int columnIndex)
	{
		CompressorFileLine line = (CompressorFileLine)fileLines.get(rowIndex);
		switch (columnIndex)
		{
			case NAME:      return line.compressor.getName();
			case SIZE:      return new Long(line.getSize());
			default: throw new Error("Unexpected case");
		}
	}

	// Returns true if the cell at rowIndex and columnIndex is editable.
    public boolean 	isCellEditable(int rowIndex, int columnIndex)
	{	return false;	}

	// Sets the value in the cell at columnIndex and rowIndex to aValue.
	public void 	setValueAt(Object aValue, int rowIndex, int columnIndex)
	{	throw new Error("Table not editable");	}




	public void addCompressor(Compressor compressor, long size)
	{
		int row =   fileLines.size();
		fileLines.add(new CompressorFileLine(compressor, size));
		fireTableRowsInserted(row, row);
	}



	public void clear()
	{
		this.fileLines.clear();
		super.fireTableStructureChanged();
	}

}



public class CompressorTable extends JTable
{
	CompressorModel           model;
//	ProgressCellRenderer    pcr = new ProgressCellRenderer();

	public CompressorTable()
    {
		this(new CompressorModel());

//		this.setDefaultRenderer(CompressorFileLine.class, pcr);
    }

	public CompressorTable(CompressorModel model)
	{
		super(model);
		this.model = model;
	}


    public void addCompressor(Compressor compressor, long size)
    {
		model.addCompressor(compressor, size);
		this.setPreferredScrollableViewportSize(getPreferredSize());
    }

    public void clear()
    {
		model.clear();
    }
}
