package cellular.tui;

import cellular.Evolution;
import cellular.Rule;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.IOException;
import java.io.File;
import java.io.DataOutputStream;

/**
 * <p> </p>
 * <p> </p>
 * <p> Copyright (c) 2003</p>
 * <p> WoCoWa</p>
 * @author Wouter Koolen-Wijkstra
 * @version 1.0
 */

public class Main
{

    public Main(String [] args)
    {
		if (args.length != 5)
		{
			System.err.println("Usage: " + getClass() + " <symbols> <context> <initial> <generations> <filename>");
			return;
		}

		try
		{
			int     symbols =       Integer.parseInt(args[0]);
			int     context =       Integer.parseInt(args[1]);
			int     initial =       Integer.parseInt(args[2]);
			int     generations =   Integer.parseInt(args[3]);
			File    target =        new File(args[4]);

			Rule        r =         new Rule(symbols, 2*context+1);
			Evolution   e =         new Evolution(generations, r, initial);

			OutputStream os =       new FileOutputStream(target);

			e.write(new DataOutputStream(os));

			os.close();
		}
		catch (NumberFormatException ex)
		{
			throw new Error(ex);
		}
		catch (IOException ex)
		{
			throw new Error(ex);
		}
    }


	public static void main(String[] args)
    {
		new Main(args);
    }
}